Debian Bug report logs - #347581
Allow library source packages to generate *-headers binary packages

version graph

Package: debian-policy; Maintainer for debian-policy is Debian Policy List <debian-policy@lists.debian.org>; Source for debian-policy is src:debian-policy.

Reported by: "Kevin B. McCarty" <kmccarty@debian.org>

Date: Wed, 11 Jan 2006 16:33:01 UTC

Severity: wishlist

Found in version debian-policy/3.6.2.2

Fixed in version debian-policy/3.9.0.0

Done: Russ Allbery <rra@debian.org>

Bug is archived. No further changes may be made.

Toggle useless messages

View this report as an mbox folder, status mbox, maintainer mbox


Report forwarded to debian-bugs-dist@lists.debian.org, debian-devel@lists.debian.org, Debian Policy List <debian-policy@lists.debian.org>:
Bug#347581; Package debian-policy. Full text and rfc822 format available.

Acknowledgement sent to "Kevin B. McCarty" <kmccarty@Princeton.EDU>:
New Bug report received and forwarded. Copy sent to debian-devel@lists.debian.org, Debian Policy List <debian-policy@lists.debian.org>. Full text and rfc822 format available.

Message #5 received at submit@bugs.debian.org (full text, mbox):

From: "Kevin B. McCarty" <kmccarty@Princeton.EDU>
To: submit@bugs.debian.org
Subject: debian-policy: Explicitly permit *-headers binary package created from library source package
Date: Wed, 11 Jan 2006 11:19:05 -0500
-----BEGIN PGP SIGNED MESSAGE-----
Hash: SHA1

Package: debian-policy
Severity: wishlist
Version: 3.6.2.2

Hi,

Could Policy be amended slightly to explicitly permit library source
packages to create a <library>-headers package containing include files?

I am thinking that something like the following could be added between
the existing first and second paragraphs of Section 8.4, "Development
files",
http://www.debian.org/doc/debian-policy/ch-sharedlibs.html#s-sharedlibs-dev

[begin suggested text]
If your library source package includes a large number of header files
that are to be installed in /usr/include or subdirectories thereof, it
may place them in a binary package called librarynamesoversion-headers
or (if you prefer only to support one development version at a time, or
if the library API is preserved across different soversions)
libraryname-headers.  If you do this, the development package must
Depend upon the headers package.  If the development package is
architecture-dependent and the headers package is not, the development
package should not require exactly the same version of the headers
package in order to prevent problems arising from binary NMUs.
[end suggested text]

Without this or a similar text, it is not clear to me that source
packages creating <library>-headers binary packages are in compliance
with Policy, which currently says "The development files associated to a
shared library need to be placed in a package called
librarynamesoversion-dev, or if you prefer only to support one
development version at a time, libraryname-dev."

The following library source packages of which I am aware create
- -headers packages that are in compliance with the suggested amendment
above:

. affix-kernel
. atlas3
. qt-x11-free (Qt3)
. wxwindows2.4
. wxwidgets2.6

The following library source package creates a -headers package that is
not quite in compliance:

. newlib (has exact version dependency of arch:any -dev package on
arch:all -headers package)

Some other source packages creating -headers packages to which this
suggested policy amendment would not apply:

. *-kernel-headers (not created from a library source package)
. em8300-headers (ditto)
. octave2.1 (the shared libs aren't in /usr/lib, nor does the package
tweak ld.so.conf so that they're visible to the runtime linker, so I
don't believe this counts as a library source package)
. octave2.9 (ditto)


CC'ed to debian-devel in case anyone wants to add to or disagree with
this suggestion.

regards,

- --
Kevin B. McCarty <kmccarty@princeton.edu>   Physics Department
WWW: http://www.princeton.edu/~kmccarty/    Princeton University
GPG: public key ID 4F83C751                 Princeton, NJ 08544
-----BEGIN PGP SIGNATURE-----
Version: GnuPG v1.4.1 (GNU/Linux)
Comment: Using GnuPG with Thunderbird - http://enigmail.mozdev.org

iD8DBQFDxS/5fYxAIk+Dx1ERAnK+AKC9+FmXe/NiDmtpuUU/T7kLcX2SogCgqrQr
CQp3MCVPmgLqq6loQfnccwg=
=eVUJ
-----END PGP SIGNATURE-----



Information forwarded to debian-bugs-dist@lists.debian.org, Debian Policy List <debian-policy@lists.debian.org>:
Bug#347581; Package debian-policy. Full text and rfc822 format available.

Acknowledgement sent to Brian Nelson <pyro@debian.org>:
Extra info received and forwarded to list. Copy sent to Debian Policy List <debian-policy@lists.debian.org>. Full text and rfc822 format available.

Message #10 received at 347581@bugs.debian.org (full text, mbox):

From: Brian Nelson <pyro@debian.org>
To: "Kevin B. McCarty" <kmccarty@Princeton.EDU>
Cc: 347581@bugs.debian.org
Subject: Re: Bug#347581: debian-policy: Explicitly permit *-headers binary package created from library source package
Date: Wed, 11 Jan 2006 09:24:58 -0800
"Kevin B. McCarty" <kmccarty@Princeton.EDU> writes:

> Could Policy be amended slightly to explicitly permit library source
> packages to create a <library>-headers package containing include files?
>
> I am thinking that something like the following could be added between
> the existing first and second paragraphs of Section 8.4, "Development
> files",
> http://www.debian.org/doc/debian-policy/ch-sharedlibs.html#s-sharedlibs-dev
>
> [begin suggested text]
> If your library source package includes a large number of header files
> that are to be installed in /usr/include or subdirectories thereof, it
> may place them in a binary package called librarynamesoversion-headers
> or (if you prefer only to support one development version at a time, or
> if the library API is preserved across different soversions)
> libraryname-headers.  If you do this, the development package must
> Depend upon the headers package.  If the development package is
> architecture-dependent and the headers package is not, the development
> package should not require exactly the same version of the headers
> package in order to prevent problems arising from binary NMUs.
> [end suggested text]
>
> Without this or a similar text, it is not clear to me that source
> packages creating <library>-headers binary packages are in compliance
> with Policy, which currently says "The development files associated to a
> shared library need to be placed in a package called
> librarynamesoversion-dev, or if you prefer only to support one
> development version at a time, libraryname-dev."

It's not clear to me that splitting out the headers is actually a good
thing (it's very annoying for autobuilders since the corresponding -dev
package won't be installable until the new version has been autobuilt),
so I certainly don't think policy should endorse it.

> CC'ed to debian-devel in case anyone wants to add to or disagree with
> this suggestion.

Uh, no it's not.

-- 
Captain Logic is not steering this tugboat.



Information forwarded to debian-bugs-dist@lists.debian.org, Debian Policy List <debian-policy@lists.debian.org>:
Bug#347581; Package debian-policy. Full text and rfc822 format available.

Acknowledgement sent to "Kevin B. McCarty" <kmccarty@Princeton.EDU>:
Extra info received and forwarded to list. Copy sent to Debian Policy List <debian-policy@lists.debian.org>. Full text and rfc822 format available.

Message #15 received at 347581@bugs.debian.org (full text, mbox):

From: "Kevin B. McCarty" <kmccarty@Princeton.EDU>
To: Brian Nelson <pyro@debian.org>
Cc: 347581@bugs.debian.org
Subject: Re: Bug#347581: debian-policy: Explicitly permit *-headers binary package created from library source package
Date: Wed, 11 Jan 2006 12:40:24 -0500
Brian Nelson wrote:

> It's not clear to me that splitting out the headers is actually a good
> thing (it's very annoying for autobuilders since the corresponding -dev
> package won't be installable until the new version has been autobuilt),
> so I certainly don't think policy should endorse it.

It wouldn't be an endorsement, just a permission.  It seems to me that
policy currently prohibits -headers packages for shared libraries by
saying that development files must be in the -dev package.  Do you feel
-headers packages _should_ be explicitly prohibited?

My main motive in making the suggestion is that when the headers are
architecture-independent and there are a lot of them, splitting them out
into a separate arch:all package can save a lot of archive space.  (I
don't know what the motive was of the developers who created packages
like libqt3-headers, which are arch:any.)

> "Kevin B. McCarty" <kmccarty@Princeton.EDU> writes:
>>CC'ed to debian-devel in case anyone wants to add to or disagree with
>>this suggestion.
> 
> Uh, no it's not.

For "CC'ed" read "X-Debbugs-CC'ed".  The web archive of the mailing list
hasn't been updated since early this morning (as of this writing), but
you can see my email in the gated newsgroup, for instance on Google
Groups, http://groups.google.com/group/linux.debian.devel .
If it isn't showing up to debian-devel email subscribers, something
strange is going on (I read the list through the web archive so I don't
know whether or not this is the case).

regards,

-- 
Kevin B. McCarty <kmccarty@princeton.edu>   Physics Department
WWW: http://www.princeton.edu/~kmccarty/    Princeton University
GPG: public key ID 4F83C751                 Princeton, NJ 08544



Information forwarded to debian-bugs-dist@lists.debian.org, Debian Policy List <debian-policy@lists.debian.org>:
Bug#347581; Package debian-policy. Full text and rfc822 format available.

Acknowledgement sent to Brian Nelson <pyro@debian.org>:
Extra info received and forwarded to list. Copy sent to Debian Policy List <debian-policy@lists.debian.org>. Full text and rfc822 format available.

Message #20 received at 347581@bugs.debian.org (full text, mbox):

From: Brian Nelson <pyro@debian.org>
To: "Kevin B. McCarty" <kmccarty@Princeton.EDU>
Cc: 347581@bugs.debian.org
Subject: Re: Bug#347581: debian-policy: Explicitly permit *-headers binary package created from library source package
Date: Wed, 11 Jan 2006 09:50:53 -0800
"Kevin B. McCarty" <kmccarty@Princeton.EDU> writes:

> Brian Nelson wrote:
>
>> It's not clear to me that splitting out the headers is actually a good
>> thing (it's very annoying for autobuilders since the corresponding -dev
>> package won't be installable until the new version has been autobuilt),
>> so I certainly don't think policy should endorse it.
>
> It wouldn't be an endorsement, just a permission.  It seems to me that
> policy currently prohibits -headers packages for shared libraries by
> saying that development files must be in the -dev package.  Do you feel
> -headers packages _should_ be explicitly prohibited?

Sure, I don't see any advantage to having them.

> My main motive in making the suggestion is that when the headers are
> architecture-independent and there are a lot of them, splitting them out
> into a separate arch:all package can save a lot of archive space.  (I
> don't know what the motive was of the developers who created packages
> like libqt3-headers, which are arch:any.)

Get:1 http://rubeus sid/main libqt3-headers 3:3.3.5-3 [364kB]
Fetched 364kB in 1s (226kB/s)

I wouldn't call 364kB a lot of saved archive space, and you'd be
hard-pressed to find a package with more headers than Qt.

>> "Kevin B. McCarty" <kmccarty@Princeton.EDU> writes:
>>>CC'ed to debian-devel in case anyone wants to add to or disagree with
>>>this suggestion.
>> 
>> Uh, no it's not.
>
> For "CC'ed" read "X-Debbugs-CC'ed".  The web archive of the mailing list
> hasn't been updated since early this morning (as of this writing), but
> you can see my email in the gated newsgroup, for instance on Google
> Groups, http://groups.google.com/group/linux.debian.devel .
> If it isn't showing up to debian-devel email subscribers, something
> strange is going on (I read the list through the web archive so I don't
> know whether or not this is the case).

Oh, I guess the mail I replied to hadn't been processed by the submit
bot then.  My mistake.

-- 
Captain Logic is not steering this tugboat.



Information forwarded to debian-bugs-dist@lists.debian.org, Debian Policy List <debian-policy@lists.debian.org>:
Bug#347581; Package debian-policy. Full text and rfc822 format available.

Acknowledgement sent to "Kevin B. McCarty" <kmccarty@Princeton.EDU>:
Extra info received and forwarded to list. Copy sent to Debian Policy List <debian-policy@lists.debian.org>. Full text and rfc822 format available.

Message #25 received at 347581@bugs.debian.org (full text, mbox):

From: "Kevin B. McCarty" <kmccarty@Princeton.EDU>
To: Brian Nelson <pyro@debian.org>
Cc: 347581@bugs.debian.org
Subject: Re: Bug#347581: debian-policy: Explicitly permit *-headers binary package created from library source package
Date: Wed, 11 Jan 2006 13:04:44 -0500
Brian Nelson wrote:

> Get:1 http://rubeus sid/main libqt3-headers 3:3.3.5-3 [364kB]
> Fetched 364kB in 1s (226kB/s)
> 
> I wouldn't call 364kB a lot of saved archive space, and you'd be
> hard-pressed to find a package with more headers than Qt.

I'm actually working on unofficial packages of Geant 4 that might go
into Debian if upstream ever clarifies their license situation, and I
currently have

benjo (sid)[126]:~% ls -l src/GEANT4/geant4-headers_4.8.0-1_all.deb
-rw-r--r-- 1 kmccarty kmccarty 1300680 2006-01-11 11:58
src/GEANT4/geant4-headers_4.8.0-1_all.deb

but I guess even 11 * (1.3 MB) isn't so much compared to the full
archive size.

If the general attitude of debian-devel is that this bug should be
closed, fine -- I don't have a deep emotional investment in it :-)
Although in that case someone may want to file policy bugs against the
headers packages I mentioned in the original email.

regards,

-- 
Kevin B. McCarty <kmccarty@princeton.edu>   Physics Department
WWW: http://www.princeton.edu/~kmccarty/    Princeton University
GPG: public key ID 4F83C751                 Princeton, NJ 08544



Information forwarded to debian-bugs-dist@lists.debian.org, Debian Policy List <debian-policy@lists.debian.org>:
Bug#347581; Package debian-policy. Full text and rfc822 format available.

Acknowledgement sent to Roger Leigh <rleigh@whinlatter.ukfsn.org>:
Extra info received and forwarded to list. Copy sent to Debian Policy List <debian-policy@lists.debian.org>. Full text and rfc822 format available.

Message #30 received at 347581@bugs.debian.org (full text, mbox):

From: Roger Leigh <rleigh@whinlatter.ukfsn.org>
To: "Kevin B. McCarty" <kmccarty@Princeton.EDU>
Cc: 347581@bugs.debian.org, Brian Nelson <pyro@debian.org>
Subject: Re: Bug#347581: debian-policy: Explicitly permit *-headers binary package created from library source package
Date: Wed, 11 Jan 2006 18:39:30 +0000
-----BEGIN PGP SIGNED MESSAGE-----
Hash: SHA1

"Kevin B. McCarty" <kmccarty@Princeton.EDU> writes:

> Brian Nelson wrote:
>
>> It's not clear to me that splitting out the headers is actually a good
>> thing (it's very annoying for autobuilders since the corresponding -dev
>> package won't be installable until the new version has been autobuilt),
>> so I certainly don't think policy should endorse it.
>
> It wouldn't be an endorsement, just a permission.  It seems to me that
> policy currently prohibits -headers packages for shared libraries by
> saying that development files must be in the -dev package.  Do you feel
> -headers packages _should_ be explicitly prohibited?

If we do anything, IMO it should be to drop static libraries, in which
case in most cases the -dev package could then become arch-all in any
case (most -dev packages only contain a static lib as the
arch-dependent part).


Regards,
Roger

- -- 
Roger Leigh
                Printing on GNU/Linux?  http://gimp-print.sourceforge.net/
                Debian GNU/Linux        http://www.debian.org/
                GPG Public Key: 0x25BFB848.  Please sign and encrypt your mail.
-----BEGIN PGP SIGNATURE-----
Version: GnuPG v1.4.2 (GNU/Linux)
Comment: Processed by Mailcrypt 3.5.8+ <http://mailcrypt.sourceforge.net/>

iD8DBQFDxVDgVcFcaSW/uEgRAng1AKCi6aD0w2g+GSqBtGE1jvSolcqh3QCgmd5x
yGrXmbZdJkAQIW21b0CpHXA=
=90u1
-----END PGP SIGNATURE-----



Information forwarded to debian-bugs-dist@lists.debian.org, Debian Policy List <debian-policy@lists.debian.org>:
Bug#347581; Package debian-policy. Full text and rfc822 format available.

Acknowledgement sent to Bill Allombert <Bill.Allombert@math.u-bordeaux1.fr>:
Extra info received and forwarded to list. Copy sent to Debian Policy List <debian-policy@lists.debian.org>. Full text and rfc822 format available.

Message #35 received at 347581@bugs.debian.org (full text, mbox):

From: Bill Allombert <Bill.Allombert@math.u-bordeaux1.fr>
To: "Kevin B. McCarty" <kmccarty@Princeton.EDU>, 347581@bugs.debian.org
Cc: Brian Nelson <pyro@debian.org>
Subject: Re: Bug#347581: debian-policy: Explicitly permit *-headers binary package created from library source package
Date: Wed, 11 Jan 2006 19:46:11 +0100
On Wed, Jan 11, 2006 at 01:04:44PM -0500, Kevin B. McCarty wrote:
> benjo (sid)[126]:~% ls -l src/GEANT4/geant4-headers_4.8.0-1_all.deb
> -rw-r--r-- 1 kmccarty kmccarty 1300680 2006-01-11 11:58
> src/GEANT4/geant4-headers_4.8.0-1_all.deb
> 
> but I guess even 11 * (1.3 MB) isn't so much compared to the full
> archive size.

Are you sure they are architecture-independant ? 

> If the general attitude of debian-devel is that this bug should be
> closed, fine -- I don't have a deep emotional investment in it :-)
> Although in that case someone may want to file policy bugs against the
> headers packages I mentioned in the original email.

As far as I am concerned, I have no objections on the -headers packages, 
provided there exists a -dev package that depends on it and that it is
worth the extra Packages lines.

Cheers,
Bill.



Information forwarded to debian-bugs-dist@lists.debian.org, Debian Policy List <debian-policy@lists.debian.org>:
Bug#347581; Package debian-policy. Full text and rfc822 format available.

Acknowledgement sent to "Kevin B. McCarty" <kmccarty@Princeton.EDU>:
Extra info received and forwarded to list. Copy sent to Debian Policy List <debian-policy@lists.debian.org>. Full text and rfc822 format available.

Message #40 received at 347581@bugs.debian.org (full text, mbox):

From: "Kevin B. McCarty" <kmccarty@Princeton.EDU>
To: Bill Allombert <Bill.Allombert@math.u-bordeaux1.fr>
Cc: 347581@bugs.debian.org
Subject: Re: Bug#347581: debian-policy: Explicitly permit *-headers binary package created from library source package
Date: Wed, 11 Jan 2006 14:08:26 -0500
Bill Allombert wrote:
> On Wed, Jan 11, 2006 at 01:04:44PM -0500, Kevin B. McCarty wrote:
> 
>>benjo (sid)[126]:~% ls -l src/GEANT4/geant4-headers_4.8.0-1_all.deb
>>-rw-r--r-- 1 kmccarty kmccarty 1300680 2006-01-11 11:58
>>src/GEANT4/geant4-headers_4.8.0-1_all.deb
>>
>>but I guess even 11 * (1.3 MB) isn't so much compared to the full
>>archive size.

> Are you sure they are architecture-independant ? 

Pretty darn certain.  Upstream's build process just copies the header
files out of the source code into a single directory at "make install"
time.  They are part of the source tree, not auto-generated.  Not even
any of the #ifdefs are arch-dependent, unless you count #ifdef WIN32
which I think can be safely ignored :-)

regards,

-- 
Kevin B. McCarty <kmccarty@princeton.edu>   Physics Department
WWW: http://www.princeton.edu/~kmccarty/    Princeton University
GPG: public key ID 4F83C751                 Princeton, NJ 08544



Information forwarded to debian-bugs-dist@lists.debian.org, Debian Policy List <debian-policy@lists.debian.org>:
Bug#347581; Package debian-policy. Full text and rfc822 format available.

Acknowledgement sent to Chris Waters <xtifr@debian.org>:
Extra info received and forwarded to list. Copy sent to Debian Policy List <debian-policy@lists.debian.org>. Full text and rfc822 format available.

Message #45 received at 347581@bugs.debian.org (full text, mbox):

From: Chris Waters <xtifr@debian.org>
To: "Kevin B. McCarty" <kmccarty@Princeton.EDU>, 347581@bugs.debian.org
Subject: Re: Bug#347581: debian-policy: Explicitly permit *-headers binary package created from library source package
Date: Thu, 12 Jan 2006 02:47:58 -0800
On Wed, Jan 11, 2006 at 11:19:05AM -0500, Kevin B. McCarty wrote:

> Could Policy be amended slightly to explicitly permit library source
> packages to create a <library>-headers package containing include files?

I would rather see it modified to not forbid it than add a whole
paragraph to explicitly permit it.  I think the suggested text is much
too long.  I'm not objecting to the idea; merely the wording.

[proposed paragraph elided]

> Without this or a similar text, it is not clear to me that source
> packages creating <library>-headers binary packages are in compliance
> with Policy, which currently says "The development files associated to a
> shared library need to be placed in a package called
> librarynamesoversion-dev, or if you prefer only to support one
> development version at a time, libraryname-dev."

I would rather see that last sentence modified slightly to allow a
little more flexibility.  Perhaps changing "placed in" to "placed in
or installed by".  Or something along those lines.

If you can come up with something like that which allows you to do
what you want, without going into excessive and unnecessary detail, I
can probably be persuaded to second it.

-- 
Chris Waters           |  Pneumonoultra-        osis is too long
xtifr@debian.org       |  microscopicsilico-    to fit into a single
or xtifr@speakeasy.net |  volcaniconi-          standalone haiku



Information forwarded to debian-bugs-dist@lists.debian.org, Debian Policy List <debian-policy@lists.debian.org>:
Bug#347581; Package debian-policy. Full text and rfc822 format available.

Acknowledgement sent to "Kevin B. McCarty" <kmccarty@Princeton.EDU>:
Extra info received and forwarded to list. Copy sent to Debian Policy List <debian-policy@lists.debian.org>. Full text and rfc822 format available.

Message #50 received at 347581@bugs.debian.org (full text, mbox):

From: "Kevin B. McCarty" <kmccarty@Princeton.EDU>
To: 347581@bugs.debian.org
Cc: xtifr@debian.org
Subject: Re: Bug#347581: debian-policy: Explicitly permit *-headers binary package created from library source package
Date: Thu, 12 Jan 2006 14:22:07 -0500
-----BEGIN PGP SIGNED MESSAGE-----
Hash: SHA1

Chris Waters wrote:
> On Wed, Jan 11, 2006 at 11:19:05AM -0500, Kevin B. McCarty wrote:

>>Without this or a similar text, it is not clear to me that source
>>packages creating <library>-headers binary packages are in compliance
>>with Policy, which currently says "The development files associated to a
>>shared library need to be placed in a package called
>>librarynamesoversion-dev, or if you prefer only to support one
>>development version at a time, libraryname-dev."
> 
> I would rather see that last sentence modified slightly to allow a
> little more flexibility.  Perhaps changing "placed in" to "placed in
> or installed by".  Or something along those lines.

Hmm, how about this?  (I can't quite see how to keep it to a single
sentence of reasonable length.)

"If there are development files associated to a shared library, the
source package needs to generate a binary development package called
librarynamesoversion-dev, or if you prefer only to support one
development version at a time, libraryname-dev.  Installing the
development package must result in installation of all the development
files."

This change would leave the door open for development files to be split
up into separate packages as needed, as long as lib<whatever>-dev
depends upon all of them, either directly or indirectly.

- --
Kevin B. McCarty <kmccarty@princeton.edu>   Physics Department
WWW: http://www.princeton.edu/~kmccarty/    Princeton University
GPG: public key ID 4F83C751                 Princeton, NJ 08544
-----BEGIN PGP SIGNATURE-----
Version: GnuPG v1.4.1 (GNU/Linux)
Comment: Using GnuPG with Thunderbird - http://enigmail.mozdev.org

iD8DBQFDxqxffYxAIk+Dx1ERAq7BAJ45NWQTVTONEpjioHS9MuQ+HfVzuQCfekjQ
+0cx8IB0WddGCk+pGVsKTqg=
=hcZW
-----END PGP SIGNATURE-----



Changed Bug submitter from "Kevin B. McCarty" <kmccarty@Princeton.EDU> to "Kevin B. McCarty" <kmccarty@debian.org>. Request was from "Kevin B. McCarty" <kmccarty@debian.org> to control@bugs.debian.org. (Wed, 05 Dec 2007 17:24:21 GMT) Full text and rfc822 format available.

Changed Bug title to `Allow library source packages to generate *-headers binary packages' from `debian-policy: Explicitly permit *-headers binary package created from library source package'. Request was from Russ Allbery <rra@debian.org> to control@bugs.debian.org. (Mon, 17 Mar 2008 05:24:33 GMT) Full text and rfc822 format available.

Information forwarded to debian-bugs-dist@lists.debian.org, Debian Policy List <debian-policy@lists.debian.org>:
Bug#347581; Package debian-policy. (Sat, 12 Jun 2010 20:06:03 GMT) Full text and rfc822 format available.

Acknowledgement sent to Russ Allbery <rra@debian.org>:
Extra info received and forwarded to list. Copy sent to Debian Policy List <debian-policy@lists.debian.org>. (Sat, 12 Jun 2010 20:06:03 GMT) Full text and rfc822 format available.

Message #59 received at 347581@bugs.debian.org (full text, mbox):

From: Russ Allbery <rra@debian.org>
To: "Kevin B. McCarty" <kmccarty@Princeton.EDU>
Cc: 347581@bugs.debian.org, xtifr@debian.org
Subject: Re: Bug#347581: debian-policy: Explicitly permit *-headers binary package created from library source package
Date: Sat, 12 Jun 2010 13:01:57 -0700
For background here, this bug is about permitting the splitting of the
architecture-independent headers for a library into a separate -headers
package rather than requiring (which the current Policy wording implies)
that they be in the usually architecture-dependent -dev package.

"Kevin B. McCarty" <kmccarty@Princeton.EDU> writes:
> Chris Waters wrote:

>> I would rather see that last sentence modified slightly to allow a
>> little more flexibility.  Perhaps changing "placed in" to "placed in or
>> installed by".  Or something along those lines.

> Hmm, how about this?  (I can't quite see how to keep it to a single
> sentence of reasonable length.)

> "If there are development files associated to a shared library, the
> source package needs to generate a binary development package called
> librarynamesoversion-dev, or if you prefer only to support one
> development version at a time, libraryname-dev.  Installing the
> development package must result in installation of all the development
> files."

> This change would leave the door open for development files to be split
> up into separate packages as needed, as long as lib<whatever>-dev
> depends upon all of them, either directly or indirectly.

This looks good to me.  Here's proposed wording.  Objections or seconds?

diff --git a/policy.sgml b/policy.sgml
index 720150d..1e134bb 100644
--- a/policy.sgml
+++ b/policy.sgml
@@ -5163,11 +5163,20 @@ Replaces: mail-transport-agent
 	<heading>Development files</heading>
 
       <p>
-	The development files associated to a shared library need to be
-	placed in a package called
-	<package><var>libraryname</var><var>soversion</var>-dev</package>,
+	If there are development files associated with a shared library,
+	the source package needs to generate a binary development package
+	named <package><var>libraryname</var><var>soversion</var>-dev</package>,
 	or if you prefer only to support one development version at a
-	time, <package><var>libraryname</var>-dev</package>.
+	time, <package><var>libraryname</var>-dev</package>.  Installing
+	the development package must result in installation of all the
+	development files necessary for compiling programs against that
+	shared library.<footnote>
+	  This wording allows the development files to be split into
+	  several packages, such as a separate architecture-independent
+	  <package><var>libraryname</var>-headers</package>, provided that
+	  the development package depends on all the required additional
+	  packages.
+	</footnote>
       </p>
 
       <p>

-- 
Russ Allbery (rra@debian.org)               <http://www.eyrie.org/~eagle/>




Added tag(s) patch. Request was from Russ Allbery <rra@debian.org> to control@bugs.debian.org. (Sat, 12 Jun 2010 20:06:05 GMT) Full text and rfc822 format available.

Information forwarded to debian-bugs-dist@lists.debian.org, Debian Policy List <debian-policy@lists.debian.org>:
Bug#347581; Package debian-policy. (Sat, 12 Jun 2010 23:06:03 GMT) Full text and rfc822 format available.

Acknowledgement sent to Julien Cristau <jcristau@debian.org>:
Extra info received and forwarded to list. Copy sent to Debian Policy List <debian-policy@lists.debian.org>. (Sat, 12 Jun 2010 23:06:03 GMT) Full text and rfc822 format available.

Message #66 received at 347581@bugs.debian.org (full text, mbox):

From: Julien Cristau <jcristau@debian.org>
To: Russ Allbery <rra@debian.org>, 347581@bugs.debian.org
Cc: "Kevin B. McCarty" <kmccarty@Princeton.EDU>, xtifr@debian.org
Subject: Re: Bug#347581: debian-policy: Explicitly permit *-headers binary package created from library source package
Date: Sun, 13 Jun 2010 01:04:15 +0200
[Message part 1 (text/plain, inline)]
On Sat, Jun 12, 2010 at 13:01:57 -0700, Russ Allbery wrote:

> diff --git a/policy.sgml b/policy.sgml
> index 720150d..1e134bb 100644
> --- a/policy.sgml
> +++ b/policy.sgml
> @@ -5163,11 +5163,20 @@ Replaces: mail-transport-agent
>  	<heading>Development files</heading>
>  
>        <p>
> -	The development files associated to a shared library need to be
> -	placed in a package called
> -	<package><var>libraryname</var><var>soversion</var>-dev</package>,
> +	If there are development files associated with a shared library,
> +	the source package needs to generate a binary development package
> +	named <package><var>libraryname</var><var>soversion</var>-dev</package>,
>  	or if you prefer only to support one development version at a
> -	time, <package><var>libraryname</var>-dev</package>.
> +	time, <package><var>libraryname</var>-dev</package>.  Installing
> +	the development package must result in installation of all the
> +	development files necessary for compiling programs against that
> +	shared library.<footnote>
> +	  This wording allows the development files to be split into
> +	  several packages, such as a separate architecture-independent
> +	  <package><var>libraryname</var>-headers</package>, provided that
> +	  the development package depends on all the required additional
> +	  packages.
> +	</footnote>
>        </p>
>  
>        <p>

Seconded.

Cheers,
Julien - who does this for libxmu{,u} and libgl{,u}, at least
[signature.asc (application/pgp-signature, inline)]

Information forwarded to debian-bugs-dist@lists.debian.org, Debian Policy List <debian-policy@lists.debian.org>:
Bug#347581; Package debian-policy. (Sun, 13 Jun 2010 21:18:06 GMT) Full text and rfc822 format available.

Acknowledgement sent to Andrew McMillan <andrew@morphoss.com>:
Extra info received and forwarded to list. Copy sent to Debian Policy List <debian-policy@lists.debian.org>. (Sun, 13 Jun 2010 21:18:07 GMT) Full text and rfc822 format available.

Message #71 received at 347581@bugs.debian.org (full text, mbox):

From: Andrew McMillan <andrew@morphoss.com>
To: Russ Allbery <rra@debian.org>, 347581@bugs.debian.org
Subject: Re: Bug#347581: debian-policy: Explicitly permit *-headers binary package created from library source package
Date: Mon, 14 Jun 2010 09:14:34 +1200
[Message part 1 (text/plain, inline)]
On Sat, 2010-06-12 at 13:01 -0700, Russ Allbery wrote:
> For background here, this bug is about permitting the splitting of the
> architecture-independent headers for a library into a separate -headers
> package rather than requiring (which the current Policy wording implies)
> that they be in the usually architecture-dependent -dev package.
> 
> "Kevin B. McCarty" <kmccarty@Princeton.EDU> writes:
> > Chris Waters wrote:
> 
> >> I would rather see that last sentence modified slightly to allow a
> >> little more flexibility.  Perhaps changing "placed in" to "placed in or
> >> installed by".  Or something along those lines.
> 
> > Hmm, how about this?  (I can't quite see how to keep it to a single
> > sentence of reasonable length.)
> 
> > "If there are development files associated to a shared library, the
> > source package needs to generate a binary development package called
> > librarynamesoversion-dev, or if you prefer only to support one
> > development version at a time, libraryname-dev.  Installing the
> > development package must result in installation of all the development
> > files."
> 
> > This change would leave the door open for development files to be split
> > up into separate packages as needed, as long as lib<whatever>-dev
> > depends upon all of them, either directly or indirectly.
> 
> This looks good to me.  Here's proposed wording.  Objections or seconds?
> 
> diff --git a/policy.sgml b/policy.sgml
> index 720150d..1e134bb 100644
> --- a/policy.sgml
> +++ b/policy.sgml
> @@ -5163,11 +5163,20 @@ Replaces: mail-transport-agent
>  	<heading>Development files</heading>
>  
>        <p>
> -	The development files associated to a shared library need to be
> -	placed in a package called
> -	<package><var>libraryname</var><var>soversion</var>-dev</package>,
> +	If there are development files associated with a shared library,
> +	the source package needs to generate a binary development package
> +	named <package><var>libraryname</var><var>soversion</var>-dev</package>,
>  	or if you prefer only to support one development version at a
> -	time, <package><var>libraryname</var>-dev</package>.
> +	time, <package><var>libraryname</var>-dev</package>.  Installing
> +	the development package must result in installation of all the
> +	development files necessary for compiling programs against that
> +	shared library.<footnote>
> +	  This wording allows the development files to be split into
> +	  several packages, such as a separate architecture-independent
> +	  <package><var>libraryname</var>-headers</package>, provided that
> +	  the development package depends on all the required additional
> +	  packages.
> +	</footnote>
>        </p>
>  
>        <p>

Seconded.

Cheers,
						Andrew.


-- 
------------------------------------------------------------------------
andrew (AT) morphoss (DOT) com                            +64(272)DEBIAN
              Does the turtle move for you?  www.kame.net
------------------------------------------------------------------------

[signature.asc (application/pgp-signature, inline)]

Information forwarded to debian-bugs-dist@lists.debian.org, Debian Policy List <debian-policy@lists.debian.org>:
Bug#347581; Package debian-policy. (Mon, 14 Jun 2010 17:51:02 GMT) Full text and rfc822 format available.

Acknowledgement sent to Russ Allbery <rra@debian.org>:
Extra info received and forwarded to list. Copy sent to Debian Policy List <debian-policy@lists.debian.org>. (Mon, 14 Jun 2010 17:51:02 GMT) Full text and rfc822 format available.

Message #76 received at 347581@bugs.debian.org (full text, mbox):

From: Russ Allbery <rra@debian.org>
To: 347581@bugs.debian.org
Cc: xtifr@debian.org
Subject: Re: Bug#347581: debian-policy: Explicitly permit *-headers binary package created from library source package
Date: Mon, 14 Jun 2010 10:49:46 -0700
Russ Allbery <rra@debian.org> writes:

> For background here, this bug is about permitting the splitting of the
> architecture-independent headers for a library into a separate -headers
> package rather than requiring (which the current Policy wording implies)
> that they be in the usually architecture-dependent -dev package.

[...]

This has now been merged for the next release.

-- 
Russ Allbery (rra@debian.org)               <http://www.eyrie.org/~eagle/>




Added tag(s) pending; removed tag(s) patch. Request was from Russ Allbery <rra@debian.org> to control@bugs.debian.org. (Mon, 14 Jun 2010 22:24:05 GMT) Full text and rfc822 format available.

Reply sent to Russ Allbery <rra@debian.org>:
You have taken responsibility. (Mon, 28 Jun 2010 05:21:09 GMT) Full text and rfc822 format available.

Notification sent to "Kevin B. McCarty" <kmccarty@debian.org>:
Bug acknowledged by developer. (Mon, 28 Jun 2010 05:21:09 GMT) Full text and rfc822 format available.

Message #83 received at 347581-close@bugs.debian.org (full text, mbox):

From: Russ Allbery <rra@debian.org>
To: 347581-close@bugs.debian.org
Subject: Bug#347581: fixed in debian-policy 3.9.0.0
Date: Mon, 28 Jun 2010 05:17:08 +0000
Source: debian-policy
Source-Version: 3.9.0.0

We believe that the bug you reported is fixed in the latest version of
debian-policy, which is due to be installed in the Debian FTP archive:

debian-policy_3.9.0.0.dsc
  to main/d/debian-policy/debian-policy_3.9.0.0.dsc
debian-policy_3.9.0.0.tar.gz
  to main/d/debian-policy/debian-policy_3.9.0.0.tar.gz
debian-policy_3.9.0.0_all.deb
  to main/d/debian-policy/debian-policy_3.9.0.0_all.deb



A summary of the changes between this version and the previous one is
attached.

Thank you for reporting the bug, which will now be closed.  If you
have further comments please address them to 347581@bugs.debian.org,
and the maintainer will reopen the bug report if appropriate.

Debian distribution maintenance software
pp.
Russ Allbery <rra@debian.org> (supplier of updated debian-policy package)

(This message was generated automatically at their request; if you
believe that there is a problem with it please contact the archive
administrators by mailing ftpmaster@debian.org)


-----BEGIN PGP SIGNED MESSAGE-----
Hash: SHA1

Format: 1.8
Date: Sun, 27 Jun 2010 21:40:52 -0700
Source: debian-policy
Binary: debian-policy
Architecture: source all
Version: 3.9.0.0
Distribution: unstable
Urgency: low
Maintainer: Debian Policy List <debian-policy@lists.debian.org>
Changed-By: Russ Allbery <rra@debian.org>
Description: 
 debian-policy - Debian Policy Manual and related documents
Closes: 224509 284340 328951 347581 442134 470633 478295 530687 547272 555009 555978 558430 560411 560839 562506 563425 566220 567845 569174 572253 575639 576594 577666 578854 579457 579461 582495 584521 584796 586163
Changes: 
 debian-policy (3.9.0.0) unstable; urgency=low
 .
   [ Colin Watson ]
   * Fix path to changelog.Debian.gz in footnote on documentation symlinks.
 .
   [ Bill Allombert ]
   * Convert upgrading-checklist to debiandoc-sgml. This generates a better
     looking .txt file.
     Closes: #567845
   * Fix typo in package_upstream-version.orig.tar.gz.
     Thanks, Salvatore Bonaccorso. (Closes: #558430)
   * Replace 'copyright and distribution license' by 'copyright information
     and distribution license' (three times).
     Proposed by Jonathan Nieder.
     Seconded:  Steve Langasek  <vorlon@debian.org>
     Seconded:  Thijs Kinkhorst <thijs@debian.org>
     Seconded:  Julien Cristau  <jcristau@debian.org>
     Seconded:  Gregor Herrmann <gregoa@debian.org>
     Closes: #566220
   * extend UID range of user accounts by removing the 30000-59999 reserved
     ranges.
     Proposed by Santiago Vila
     Seconded:  Russ Allbery    <rra@debian.org>
     Seconded:  Luk Claes       <luk@debian.org>
     Seconded:  Raphael Hertzog <hertzog@debian.org>
     Seconded:  Steve Langasek  <vorlon@debian.org>
     Closes: #582495
 .
   [ Russ Allbery ]
   * Policy: Overhaul Breaks, Conflicts, Provides, and Replaces
     Wording: Russ Allbery <rra@debian.org>
     Seconded: Steve Langasek <vorlon@debian.org>
     Seconded: Raphael Hertzog <hertzog@debian.org>
     Closes: #578854
   * Policy: Support for architecture wildcards
     Wording: Manoj Srivastava <srivasta@debian.org>
     Wording: Russ Allbery <rra@debian.org>
     Seconded: Guillem Jover <guillem@debian.org>
     Seconded: Andrew McMillan <andrew@morphoss.com>
     Seconded: Steve Langasek <vorlon@debian.org>
     Closes: #530687
   * Policy: Except init.d scripts from the normal set -e requirement
     Wording: Russ Allbery <rra@debian.org>
     Seconded: Raphael Hertzog <hertzog@debian.org>
     Seconded: Guillem Jover <guillem@debian.org>
     Closes: #562506
   * Policy: Maintainer scripts might not have a controlling terminal
     Wording: Russ Allbery <rra@debian.org>
     Seconded: Guillem Jover <guillem@debian.org>
     Seconded: Andrew McMillan <andrew@morphoss.com>
     Seconded: Steve Langasek <vorlon@debian.org>
     Closes: #224509
   * Policy: Fully specify the date format for changelog entries
     Wording: Charles Plessy <plessy@debian.org>
     Seconded: Russ Allbery <rra@debian.org>
     Seconded: Andrew McMillan <andrew@morphoss.com>
     Seconded: Giacomo A. Catenazzi <cate@debian.org>
     Closes: #569174
   * Policy: Deprecate /usr/share/common-licenses/BSD
     Wording: Russ Allbery <rra@debian.org>
     Seconded: Emilio Pozuelo Monfort <pochu@debian.org>
     Seconded: Jakub Wilk <jwilk@debian.org>
     Seconded: gregor herrmann <gregoa@debian.org>
     Closes: #284340
   * Policy: Document Checksums-Sha1 and Checksums-Sha256
     Wording: Russ Allbery <rra@stanford.edu>
     Seconded: Julien Cristau <jcristau@debian.org>
     Seconded: Emilio Pozuelo Monfort <pochu@debian.org>
     Closes: #478295
   * Policy: Prohibit duplicate field names in a control paragraph
     Wording: Russ Allbery <rra@debian.org>
     Seconded: Charles Plessy <plessy@debian.org>
     Seconded: Steve Langasek <vorlon@debian.org>
     Seconded: Emilio Pozuelo Monfort <pochu@debian.org>
     Closes: #555978
   * Policy: Relax requirement that library dev files be in one package
     Wording: Russ Allbery <rra@debian.org>
     Seconded: Julien Cristau <jcristau@debian.org>
     Seconded: Andrew McMillan <andrew@morphoss.com>
     Closes: #347581
   * Policy: Tighten requirements for maintainer-like fields
     Wording: Russ Allbery <rra@debian.org>
     Seconded: Emilio Pozuelo Monfort <pochu@debian.org>
     Seconded: Andrew McMillan <andrew@morphoss.com>
     Closes: #575639
   * Policy: Update Format control field documentation
     Wording: Russ Allbery <rra@debian.org>
     Wording: Charles Plessy <plessy@debian.org>
     Seconded: Charles Plessy <plessy@debian.org>
     Seconded: Emilio Pozuelo Monfort <pochu27@gmail.com>
     Closes: #547272
   * Debconf: Add SETTITLE, like title but uses a template
     Wording: Frans Pop <elendil@planet.nl>
     Seconded: Russ Allbery <rra@debian.org>
     Seconded: Ben Pfaff <blp@cs.stanford.edu>
     Closes: #560411
   * Perl Policy: Change perlapi provides to use an ABI version
     Wording: Niko Tyni <ntyni@debian.org>
     Seconded: Russ Allbery <rra@debian.org>
     Seconded: Brendan O'Dea <bod@debian.org>
     Seconded: Damyan Ivanov <dmn@debian.org>
     Closes: #579457
   * Perl Policy: Recommend DESTDIR instead of PREFIX with Makefile.PL
     Wording: Niko Tyni <ntyni@debian.org>
     Seconded: Russ Allbery <rra@debian.org>
     Seconded: Raphael Hertzog <hertzog@debian.org>
     Closes: #579461
   * Standardize dpkg state wording and bring it in line with dpkg,
     renaming Failed-Config to Half-Configured and use uniform
     capitalization and punctuation.  (Closes: #442134)
   * Remove documentation of alternative changelog formats.  This feature
     is not allowed in the Debian archive and will be documented in the
     dpkg-dev documentation instead.  The documentation that was in Policy
     was also somewhat outdated.  (Closes: #555009, see #584141)
   * Remove obsolete footnote sentence saying that dpkg-statoverride is a
     new feature and not well-known.  (Closes: #563425)
   * Clarify in the Perl Policy that perl-base is essential, not perl, and
     don't imply packages need to depend on perl-base.  (Closes: #576594)
   * Document the special debian-installer section in the list of current
     sections and add a link to the list of sections in unstable, which
     contains longer descriptions.  (Closes: #577666)
   * Remove the footnote listing every architecture known to dpkg.  This
     list can be trivially produced by dpkg-architecture -L (already
     noted), is very long, and quickly becomes out-of-date.
   * Move silly version ordering example to a footnote.  (Closes: #560839)
   * Reletter the process steps to not skip State C and use more
     traditional foreground and background colors for Process.html and
     README.html.  (Closes: #584521)
   * Fix typo in footnote about help2man.  (Closes: #584796)
   * Add an example for Replaces when a package is split.  Thanks, Uwe
     Kleine-K├Ânig.  (Closes: #572253)
   * Explicitly state that packages may remove unmodified, obsolete
     configuration files during  upgrade.  (Closes: #470633)
   * Clarify the wording around which build dependencies must be satisfied
     for different debian/rules targets and add a footnote to the
     description of the build-arch and build-indep targets explaining why
     this split does not currently work as desired.  (Closes: #328951)
   * Avoid "Debianised" or "Debianized" in favor of just "Debian" or
     "Debian package" as appropriate.  Patch from Ben Finney.
     (Closes: #586163)
   * Switch to source format 3.0 (native).
Checksums-Sha1: 
 e7274274bed3b8357edf0416fc56bea8c5fbda38 1204 debian-policy_3.9.0.0.dsc
 68440fc20a2694999ebcd0f8ee892830834214a1 685524 debian-policy_3.9.0.0.tar.gz
 90b8e568e49a305619fdf678883885da5257472c 1815308 debian-policy_3.9.0.0_all.deb
Checksums-Sha256: 
 66c2d84cf533a44f7222e01c55e4e084367fcd842bf2d2bc4d1db1357e256e9b 1204 debian-policy_3.9.0.0.dsc
 8f9ef5de4718c9a60f3438f26dc611ae4d2100de5390f1f447d9a8c06ec0ce16 685524 debian-policy_3.9.0.0.tar.gz
 1dee7e8fb58f5fbc15521fc0f5dee1205fdb789f168601a968b5d0fef44fed7b 1815308 debian-policy_3.9.0.0_all.deb
Files: 
 c71beefb49ac4aa69f6b3d04b565c670 1204 doc optional debian-policy_3.9.0.0.dsc
 908ec56efcedec9b0555c98c3394872c 685524 doc optional debian-policy_3.9.0.0.tar.gz
 95f2eb52d65901340719218486882f1a 1815308 doc optional debian-policy_3.9.0.0_all.deb

-----BEGIN PGP SIGNATURE-----
Version: GnuPG v1.4.10 (GNU/Linux)

iEYEARECAAYFAkwoLpkACgkQ+YXjQAr8dHaR4QCfWjm7h6KD6WplLtK1lg1DtCrl
3XEAn0BNzXIlAK2r2GarWYKw2Gzzhk5C
=y6Xs
-----END PGP SIGNATURE-----





Bug archived. Request was from Debbugs Internal Request <owner@bugs.debian.org> to internal_control@bugs.debian.org. (Thu, 05 Aug 2010 07:43:08 GMT) Full text and rfc822 format available.

Send a report that this bug log contains spam.


Debian bug tracking system administrator <owner@bugs.debian.org>. Last modified: Sat Apr 19 15:32:19 2014; Machine Name: buxtehude.debian.org

Debian Bug tracking system
Copyright (C) 1999 Darren O. Benham, 1997,2003 nCipher Corporation Ltd, 1994-97 Ian Jackson.